﻿using System;
using System.Diagnostics;
using System.Windows.Forms;
using SystemSupportApp.Properties;
using System.Drawing;
using Microsoft.Win32;


namespace SystemSupportApp
{
	class ContextMenus
	{
		bool isAboutLoaded = false;
 
		public ContextMenuStrip Create()
		{
			ContextMenuStrip menu = new ContextMenuStrip();
			ToolStripMenuItem item;
			ToolStripSeparator sep;

            // Add default System Information item to menu list
            item = new ToolStripMenuItem();
            item.Text = "About";
            item.Image = Resources.About;
            item.Click += new EventHandler(About_Click);
            menu.Items.Add(item);

            // Put in a seperator in menu list
            sep = new ToolStripSeparator();
            menu.Items.Add(sep);

            // Read registry for menu item lists

            const string userRoot = "HKEY_CURRENT_USER";
            const string subkey = "Software\\S&SHIS\\SystemSupportApp";
            const string RightMenu = userRoot + "\\" + subkey + "\\RightClickMenuItems"; 
            
            RegistryKey SupportApp = Registry.CurrentUser.OpenSubKey(subkey);

            if (SupportApp != null)
            {
                foreach (string subKeyName in SupportApp.GetSubKeyNames())
                {
                    using (RegistryKey FoundKey = SupportApp.OpenSubKey(subKeyName))
                    {
                        // Check to see if we have the found the key and read values 
                        if (FoundKey.Name.ToUpper() == RightMenu.ToUpper())
                        {
                            String MenuItemLine;
                            // build right click menu based on reg key values
                            foreach (string valueName in FoundKey.GetValueNames())
                            {
                                MenuItemLine = FoundKey.GetValue(valueName).ToString();
                                String[] Part = MenuItemLine.Split('@');
                                switch (Part[0])
                                {
                                    case "exec":
                                        item = new ToolStripMenuItem();
                                        item.Text = valueName;
                                        item.Click += (sender2, e2) => Exec_Click(sender2, e2, Part[1]);
                                        menu.Items.Add(item);
                                        break;

                                    case "info":
                                        // Put in a seperator in menu list
                                        sep = new ToolStripSeparator();
                                        menu.Items.Add(sep);
                                        // Add in menu info item to include reg string value
                                        item = new ToolStripMenuItem();
                                        item.Text = valueName + "  " + Part[1];
                                        menu.Items.Add(item);
                                        break;

                                    case "link":
                                        item = new ToolStripMenuItem();
                                        item.Text = valueName;
                                        menu.Items.Add(item);
                                        item.Click += (sender2, e2) => Link_Click(sender2, e2, Part[1]);
                                        break;

                                    case "prog":
                                        item = new ToolStripMenuItem();
                                        item.Text = valueName;
                                        menu.Items.Add(item);
                                        item.Click += (sender2, e2) => Prog_Click(sender2, e2, Part[1]);
                                        break;
                                }
                            }
                        }
                    }
                }
            }

   

			return menu;
		}

		void About_Click(object sender, EventArgs e)
		{
			if (!isAboutLoaded)
			{
				isAboutLoaded = true;
				new AboutBox().ShowDialog();
				isAboutLoaded = false;
			}
		}

        void Link_Click(object sender, EventArgs e, string link)
        {
            Process.Start("http://" + link);
        }

        void Exec_Click(object sender, EventArgs e, string exec)
        {
            string strCmdText;
            strCmdText = "/T:1F /K " + exec;
            Process.Start("CMD.exe",strCmdText);
        }

        void Prog_Click(object sender, EventArgs e, string prog)
        {
            Process.Start(prog);
        }
	
	}
}